Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 13405)
+++ issm/trunk/src/c/Makefile.am	(revision 13975)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @MPIINCL@ @MATLABINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @GSLINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
+AM_CPPFLAGS = @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @MPIINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @GSLINCL@ @BOOSTINCL@
 
 EXEEXT=$(ISSMEXT)
@@ -9,14 +9,5 @@
 lib_LTLIBRARIES = libISSMCore.la libISSMOverload.la libISSM.la
 endif
-if PYTHON
-lib_LIBRARIES += libISSMPython.a 
-endif
-if MATLAB
-if SHAREDLIBS
-lib_LTLIBRARIES += libISSMMatlab.la
-endif
-lib_LIBRARIES += libISSMMatlab.a 
-endif
-if MODULES
+if WRAPPERS
 if SHAREDLIBS
 lib_LTLIBRARIES += libISSMModules.la
@@ -54,4 +45,8 @@
 					./classes/objects/Constraints/SpcTransient.cpp\
 					./classes/objects/Constraints/SpcTransient.h\
+					./classes/objects/IndependentObject.h\
+					./classes/objects/IndependentObject.cpp\
+					./classes/objects/DependentObject.h\
+					./classes/objects/DependentObject.cpp\
 					./classes/DofIndexing.h\
 					./classes/DofIndexing.cpp\
@@ -63,4 +58,7 @@
 					./classes/objects/Vertex.h\
 					./classes/objects/Vertex.cpp\
+					./classes/objects/AdolcEdf.h\
+					./classes/IssmComm.h\
+					./classes/IssmComm.cpp\
 					./classes/Hook.h\
 					./classes/Hook.cpp\
@@ -152,4 +150,8 @@
 					./classes/objects/Params/TransientParam.h\
 					./classes/objects/Params/TransientParam.cpp\
+					./classes/objects/Params/DataSetParam.h\
+					./classes/objects/Params/DataSetParam.cpp\
+					./classes/objects/Profiler.h\
+					./classes/objects/Profiler.cpp\
 					./Container/Container.h\
 					./Container/Constraints.h\
@@ -182,5 +184,4 @@
 					./shared/Matrix/matrix.h\
 					./shared/Matrix/MatrixUtils.cpp\
-					./shared/Numerics/adolc_edf.h\
 					./shared/Numerics/numerics.h\
 					./shared/Numerics/Verbosity.h\
@@ -213,10 +214,5 @@
 					./shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp\
 					./shared/String/sharedstring.h\
-					./shared/Wrapper/wrappershared.h\
-					./shared/Wrapper/ModuleBoot.cpp\
-					./shared/Wrapper/ModuleEnd.cpp\
-					./shared/Sys/sys.h\
-					./shared/Sys/ProfilingStart.cpp\
-					./shared/Sys/ProfilingEnd.cpp\
+					./shared/String/DescriptorIndex.cpp\
 					./toolkits/metis/metisincludes.h\
 					./toolkits/issm/issmtoolkit.h\
@@ -230,4 +226,5 @@
 					./io/Disk/pfopen.cpp\
 					./io/Disk/pfclose.cpp\
+					./io/Disk/WriteLockFile.cpp\
 					./io/PrintfFunction.cpp\
 					./EnumDefinitions/EnumDefinitions.h\
@@ -279,8 +276,4 @@
 					./modules/InputArtificialNoisex/InputArtificialNoisex.h\
 					./modules/InputArtificialNoisex/InputArtificialNoisex.cpp\
-					./modules/TimeAdaptx/TimeAdaptx.h\
-					./modules/TimeAdaptx/TimeAdaptx.cpp\
-					./modules/UpdateVertexPositionsx/UpdateVertexPositionsx.h\
-					./modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp\
 					./modules/ConfigureObjectsx/ConfigureObjectsx.h\
 					./modules/ConfigureObjectsx/ConfigureObjectsx.cpp\
@@ -297,6 +290,4 @@
 					./modules/SmbGradientsx/SmbGradientsx.h\
 					./modules/SmbGradientsx/SmbGradientsx.cpp\
-					./modules/UpdateConstraintsx/UpdateConstraintsx.h\
-					./modules/UpdateConstraintsx/UpdateConstraintsx.cpp\
 					./modules/MeshPartitionx/MeshPartitionx.h\
 					./modules/Reducevectorgtofx/Reducevectorgtofx.cpp\
@@ -308,19 +299,7 @@
 					./modules/StringToEnumx/StringToEnumx.cpp\
 					./modules/StringToEnumx/StringToEnumx.h\
-					./modules/SystemMatricesx/SystemMatricesx.cpp\
-					./modules/SystemMatricesx/SystemMatricesx.h\
-					./modules/CreateJacobianMatrixx/CreateJacobianMatrixx.cpp\
-					./modules/CreateJacobianMatrixx/CreateJacobianMatrixx.h\
 					./modules/ConstraintsStatex/ConstraintsStatex.cpp\
 					./modules/ConstraintsStatex/ConstraintsStatex.h\
 					./modules/ConstraintsStatex/ConstraintsStateLocal.h\
-					./modules/Responsex/Responsex.h\
-					./modules/Responsex/Responsex.cpp\
-					./modules/RequestedOutputsx/RequestedOutputsx.h\
-					./modules/RequestedOutputsx/RequestedOutputsx.cpp\
-					./modules/RequestedDependentsx/RequestedDependentsx.h\
-					./modules/RequestedDependentsx/RequestedDependentsx.cpp\
-					./modules/AutodiffDriversx/AutodiffDriversx.h\
-					./modules/AutodiffDriversx/AutodiffDriversx.cpp\
 					./modules/ResetConstraintsx/ResetConstraintsx.h\
 					./modules/ResetConstraintsx/ResetConstraintsx.cpp\
@@ -340,8 +319,11 @@
 					./solutions/convergence.cpp\
 					./solutions/ProcessArguments.cpp\
-					./solutions/WriteLockFile.cpp\
 					./solutions/ResetBoundaryConditions.cpp\
 					./solutions/AnalysisConfiguration.cpp\
+					./solutions/WrapperCorePointerFromSolutionEnum.cpp\
 					./solutions/CorePointerFromSolutionEnum.cpp\
+					./solutions/EnvironmentInit.cpp\
+					./solutions/EnvironmentFinalize.cpp\
+					./solutions/ad_core.cpp\
 					./solvers/solver_linear.cpp\
 					./solvers/solver_nonlinear.cpp\
@@ -350,6 +332,7 @@
 					./classes/objects/Options/GenericOption.h\
 					./classes/objects/Options/OptionUtilities.cpp\
-					./classes/objects/Options/OptionUtilities.h
-
+					./classes/objects/Options/OptionUtilities.h\
+					./classes/RiftStruct.cpp\
+					./classes/RiftStruct.h
 #}}}
 #DAKOTA sources  {{{
@@ -358,6 +341,4 @@
 					  ./modules/InputUpdateFromDakotax/InputUpdateFromDakotax.h\
 					  ./modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp\
-					  ./modules/DakotaResponsesx/DakotaResponsesx.h\
-					  ./modules/DakotaResponsesx/DakotaResponsesx.cpp\
 					  ./modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.h\
 					  ./modules/InputUpdateFromVectorDakotax/InputUpdateFromVectorDakotax.cpp\
@@ -366,12 +347,7 @@
 					  ./modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp\
 					  ./modules/AverageOntoPartitionx/AverageOntoPartitionx.h\
-					  ./modules/Dakotax/Dakotax.h\
-					  ./modules/Dakotax/Dakotax.cpp\
-					  ./modules/Dakotax/DakotaMPI_Bcast.cpp\
-					  ./modules/Dakotax/DakotaFree.cpp\
-					  ./modules/Dakotax/SpawnCore.cpp\
-					  ./modules/Dakotax/DescriptorIndex.cpp\
 					  ./modules/ModelProcessorx/Dakota/CreateParametersDakota.cpp\
-					  ./modules/Dakotax/SpawnCoreParallel.cpp
+					  ./solutions/dakota_core.cpp\
+					  ./solutions/DakotaSpawnCore.cpp
 #}}}
 #Transient sources  {{{
@@ -437,6 +413,4 @@
 					  ./modules/ThicknessAbsMisfitx/ThicknessAbsMisfitx.h\
 					  ./modules/ThicknessAbsMisfitx/ThicknessAbsMisfitx.cpp\
-					  ./modules/CostFunctionx/CostFunctionx.h\
-					  ./modules/CostFunctionx/CostFunctionx.cpp\
 					  ./modules/Orthx/Orthx.h\
 					  ./modules/Orthx/Orthx.cpp\
@@ -445,6 +419,4 @@
 					  ./modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.cpp\
 					  ./modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h\
-					  ./modules/ThicknessAbsGradientx/ThicknessAbsGradientx.cpp\
-					  ./modules/ThicknessAbsGradientx/ThicknessAbsGradientx.h\
 					  ./modules/ThicknessAlongGradientx/ThicknessAlongGradientx.cpp\
 					  ./modules/ThicknessAlongGradientx/ThicknessAlongGradientx.h\
@@ -505,36 +477,4 @@
 						./solutions/balancethickness_core.cpp
 #}}}
-#Responses sources  {{{
-responses_sources = ./modules/MinVelx/MinVelx.h\
-					     ./modules/MinVelx/MinVelx.cpp\
-					     ./modules/MaxVelx/MaxVelx.h\
-					     ./modules/MaxVelx/MaxVelx.cpp\
-					     ./modules/MaxAbsVxx/MaxAbsVxx.h\
-					     ./modules/MaxAbsVxx/MaxAbsVxx.cpp\
-					     ./modules/MaxAbsVyx/MaxAbsVyx.h\
-					     ./modules/MaxAbsVyx/MaxAbsVyx.cpp\
-					     ./modules/MaxAbsVzx/MaxAbsVzx.h\
-					     ./modules/MaxAbsVzx/MaxAbsVzx.cpp\
-					     ./modules/MaxVxx/MaxVxx.h\
-					     ./modules/MaxVxx/MaxVxx.cpp\
-					     ./modules/MaxVyx/MaxVyx.h\
-					     ./modules/MaxVyx/MaxVyx.cpp\
-					     ./modules/MaxVzx/MaxVzx.h\
-					     ./modules/MaxVzx/MaxVzx.cpp\
-					     ./modules/MinVxx/MinVxx.h\
-					     ./modules/MinVxx/MinVxx.cpp\
-					     ./modules/MinVyx/MinVyx.h\
-					     ./modules/MinVyx/MinVyx.cpp\
-					     ./modules/MinVzx/MinVzx.h\
-					     ./modules/MinVzx/MinVzx.cpp\
-					     ./modules/TotalSmbx/TotalSmbx.h\
-					     ./modules/TotalSmbx/TotalSmbx.cpp\
-					     ./modules/IceVolumex/IceVolumex.h\
-					     ./modules/IceVolumex/IceVolumex.cpp\
-					     ./modules/ElementResponsex/ElementResponsex.h\
-					     ./modules/ElementResponsex/ElementResponsex.cpp\
-					     ./modules/MassFluxx/MassFluxx.cpp\
-					     ./modules/MassFluxx/MassFluxx.h
-#}}}
 #Slope sources  {{{
 slope_sources =  ./modules/ModelProcessorx/BedSlope/UpdateElementsBedSlope.cpp\
@@ -557,4 +497,8 @@
 				    ./classes/objects/Loads/Riftfront.h\
 				    ./modules/ConstraintsStatex/RiftConstraintsState.cpp
+#}}}
+#Android sources  {{{
+android_sources = ./android/fac.h\
+				  ./android/fac.cpp
 #}}}
 #3D sources  {{{
@@ -751,5 +695,4 @@
 					./toolkits/petsc/patches/SolverEnum.h\
 					./toolkits/petsc/patches/petscpatches.h\
-					./toolkits/petsc/patches/VecTranspose.cpp\
 					./toolkits/petsc/patches/VecToMPISerial.cpp\
 					./toolkits/petsc/patches/MatToSerial.cpp\
@@ -759,5 +702,4 @@
 					./toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp\
 					./toolkits/petsc/patches/NewMat.cpp\
-					./toolkits/petsc/patches/SerialToVec.cpp\
 					./toolkits/petsc/patches/VecFree.cpp\
 					./toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp\
@@ -765,10 +707,5 @@
 					./toolkits/petsc/patches/VecDuplicatePatch.cpp\
 					./toolkits/petsc/patches/KSPFree.cpp\
-					./toolkits/petsc/patches/ISFree.cpp\
 					./toolkits/petsc/patches/MatFree.cpp\
-					./toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp\
-					./toolkits/petsc/patches/VecPartition.cpp\
-					./toolkits/petsc/patches/MatPartition.cpp\
-					./toolkits/petsc/patches/MatInvert.cpp\
 					./toolkits/petsc/patches/MatMultPatch.cpp\
 					./toolkits/petsc/patches/ISSMToPetscMatrixType.cpp\
@@ -789,8 +726,5 @@
 mpi_sources= ./toolkits/mpi/mpiincludes.h\
 				./toolkits/mpi/patches/mpipatches.h\
-				./toolkits/mpi/patches/DetermineLocalSize.cpp\
-				./toolkits/mpi/patches/MPI_Upperrow.cpp\
-				./toolkits/mpi/patches/MPI_Lowerrow.cpp\
-				./toolkits/mpi/patches/MPI_Boundariesfromrange.cpp
+				./toolkits/mpi/patches/DetermineLocalSize.cpp
 #}}}
 #Metis sources  {{{
@@ -798,36 +732,6 @@
 					./toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp
 #}}}
-#Python sources  {{{
-python_sources=     ./python/io/pythonio.h\
-					./python/python-binding.h\
-				    ./python/io/WritePythonData.cpp\
-				    ./python/io/CheckNumPythonArguments.cpp\
-				    ./python/io/FetchPythonData.cpp
-
-#}}}
-#Matlab sources  {{{
-matlab_sources= ./toolkits/matlab/matlabincludes.h\
-				    ./matlab/matlab-binding.h\
-				    ./matlab/io/matlabio.h\
-				    ./matlab/io/MatlabNArrayToNArray.cpp\
-				    ./matlab/io/CheckNumMatlabArguments.cpp\
-				    ./matlab/io/mxGetAssignedField.cpp\
-				    ./matlab/io/WriteMatlabData.cpp\
-				    ./matlab/io/FetchMatlabData.cpp\
-				    ./matlab/io/OptionParse.cpp\
-				    ./matlab/io/MatlabMatrixToMatrix.cpp\
-				    ./matlab/io/MatlabVectorToVector.cpp\
-					 ./matlab/io/MatlabVectorToDoubleVector.cpp\
-					 ./matlab/io/MatlabMatrixToDoubleMatrix.cpp\
-					 ./matlab/io/MatlabMatrixToSeqMat.cpp\
-					 ./matlab/io/MatlabVectorToSeqVec.cpp
-#}}}
-#Matlab and Petsc sources  {{{
-matlabpetsc_sources= ./matlab/io/MatlabMatrixToPetscMat.cpp\
-					 ./matlab/io/MatlabVectorToPetscVec.cpp
-
-#}}}
 #Modules sources{{{
-module_sources= ./shared/Threads/issm_threads.h\
+modules_sources= ./shared/Threads/issm_threads.h\
 			./shared/Threads/LaunchThread.cpp\
 			./shared/Threads/PartitionRange.cpp\
@@ -842,6 +746,4 @@
 			./shared/TriMesh/SplitMeshForRifts.cpp\
 			./shared/TriMesh/TriMeshUtils.cpp\
-			./modules/AddExternalResultx/AddExternalResultx.h\
-			./modules/AddExternalResultx/AddExternalResultx.cpp\
 			./modules/Chacox/Chacox.h\
 			./modules/Chacox/Chacox.cpp\
@@ -853,4 +755,6 @@
 			./modules/TriMeshx/TriMeshx.h\
 			./modules/TriMeshx/TriMeshx.cpp\
+			./modules/TriMeshProcessRiftsx/TriMeshProcessRiftsx.h\
+			./modules/TriMeshProcessRiftsx/TriMeshProcessRiftsx.cpp\
 			./modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h\
 			./modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.cpp\
@@ -947,8 +851,4 @@
 endif
 
-if RESPONSES
-issm_sources +=  $(responses_sources)
-endif
-
 if SLOPE
 issm_sources  +=  $(slope_sources)
@@ -963,4 +863,8 @@
 endif
 
+if ANDROID
+issm_sources +=  $(android_sources)
+endif
+
 if THREED
 issm_sources +=  $(threed_sources)
@@ -973,10 +877,4 @@
 if METIS
 issm_sources +=  $(metis_sources)
-endif
-
-if PETSC
-if MATLAB
-issm_sources +=  $(matlabpetsc_sources)
-endif
 endif
 
@@ -1001,6 +899,6 @@
 endif
 
-if MODULES
-libISSMModules_a_SOURCES = $(module_sources)
+if WRAPPERS
+libISSMModules_a_SOURCES = $(modules_sources)
 libISSMModules_a_SOURCES += $(bamg_sources)
 if KRIGING
@@ -1017,17 +915,4 @@
 endif
 
-if PYTHON
-libISSMPython_a_SOURCES = $(python_sources)
-libISSMPython_a_CXXFLAGS= $(ALLCXXFLAGS)
-endif
-
-if MATLAB
-libISSMMatlab_a_SOURCES = $(matlab_sources)
-libISSMMatlab_a_CXXFLAGS= $(ALLCXXFLAGS)
-if SHAREDLIBS
-libISSMMatlab_la_SOURCES = $(libISSMMatlab_a_SOURCES)
-endif
-endif
-
 if VERSION
 AM_LDFLAGS =
@@ -1042,5 +927,13 @@
 
 #Executable {{{
+if ANDROID
+if ANDROIDEXE
 bin_PROGRAMS = issm 
+else
+bin_PROGRAMS = 
+endif
+else
+bin_PROGRAMS = issm 
+endif
 
 #Standard libraries
Index: issm/trunk/src/c/android/fac.cpp
===================================================================
--- issm/trunk/src/c/android/fac.cpp	(revision 13975)
+++ issm/trunk/src/c/android/fac.cpp	(revision 13975)
@@ -0,0 +1,26 @@
+/*!\file fac.cpp
+ * \brief: implementation of the fac class
+ */
+
+/*Headers{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./fac.h"
+
+/*}}}*/
+
+long fac::factorial(long n) {
+	long f = 1;
+	long i;
+	
+	for(i = 1; i <= n; i++){
+		f *= i;
+	}
+	
+	return f;
+}
+
Index: issm/trunk/src/c/android/fac.h
===================================================================
--- issm/trunk/src/c/android/fac.h	(revision 13975)
+++ issm/trunk/src/c/android/fac.h	(revision 13975)
@@ -0,0 +1,14 @@
+/*
+ * fac.h:  prototype fac class with a simple factorial routine
+ */
+
+#ifndef _FAC_H_
+#define _FAC_H_
+
+class fac {
+
+	public:
+		long factorial(long n);
+};
+
+#endif
Index: issm/trunk/src/c/classes/AdolcEdf.h
===================================================================
--- issm/trunk/src/c/classes/AdolcEdf.h	(revision 13975)
+++ issm/trunk/src/c/classes/AdolcEdf.h	(revision 13975)
@@ -0,0 +1,32 @@
+/*
+ * adolc_edf.h
+ *
+ *  Created on: Jun 26, 2012
+ *      Author: utke
+ */
+
+#ifndef _ADOLC_EDF_H_
+#define _ADOLC_EDF_H_
+
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
+
+struct Adolc_edf {
+    ext_diff_fct *myEDF_for_solverx_p;
+    Adolc_edf() : myEDF_for_solverx_p(0) {}
+    inline friend std::ostream& operator << ( ostream&, const Adolc_edf& );
+};
+
+std::ostream& operator << ( std::ostream& out, const Adolc_edf& a) {
+    out << a.myEDF_for_solverx_p;
+    return out;
+}
+
+#endif
+
+#endif
Index: issm/trunk/src/c/classes/DofIndexing.cpp
===================================================================
--- issm/trunk/src/c/classes/DofIndexing.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/DofIndexing.cpp	(revision 13975)
@@ -10,6 +10,6 @@
 
 #include <stdio.h>
+#include <string.h>
 #include "./classes.h"
-#include <string.h>
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../shared/shared.h"
@@ -21,15 +21,15 @@
 DofIndexing::DofIndexing(){
 
-	this->gsize=UNDEF;
-	this->fsize=UNDEF;
-	this->ssize=UNDEF;
-	this->clone=0;
-	this->f_set=NULL;
-	this->s_set=NULL;
-	this->svalues=NULL;
-	this->doftype=NULL;
-	this->gdoflist=NULL;
-	this->fdoflist=NULL;
-	this->sdoflist=NULL;
+	this->gsize    = UNDEF;
+	this->fsize    = UNDEF;
+	this->ssize    = UNDEF;
+	this->clone    = false;
+	this->f_set    = NULL;
+	this->s_set    = NULL;
+	this->svalues  = NULL;
+	this->doftype  = NULL;
+	this->gdoflist = NULL;
+	this->fdoflist = NULL;
+	this->sdoflist = NULL;
 
 }
@@ -43,10 +43,8 @@
 DofIndexing::DofIndexing(DofIndexing* in){ //copy constructor
 
-	int i;
-	this->gsize=in->gsize;
-	this->fsize=in->fsize;
-	this->ssize=in->ssize;
-	
-	this->clone=in->clone;
+	this->gsize = in->gsize;
+	this->fsize = in->fsize;
+	this->ssize = in->ssize;
+	this->clone = in->clone;
 
 	if(this->gsize>0){
@@ -58,9 +56,9 @@
 	}
 	else{
-		this->f_set=NULL;
-		this->s_set=NULL;
-		this->svalues=NULL;
-		this->doftype=NULL;
-		this->gdoflist=NULL;
+		this->f_set    = NULL;
+		this->s_set    = NULL;
+		this->svalues  = NULL;
+		this->doftype  = NULL;
+		this->gdoflist = NULL;
 	}
 	if(this->fsize>0 && this->fsize!=UNDEF)this->fdoflist=xNew<int>(this->fsize); else this->fdoflist=NULL;
@@ -95,8 +93,6 @@
 void DofIndexing::Init(int in_gsize,int* in_doftype){
 
-	int i;
 	this->gsize=in_gsize;
-	
-	this->clone=0;
+	this->clone=false;
 
 	/*allocate: */
@@ -109,5 +105,5 @@
 	}
 
-	for (i=0;i<this->gsize;i++){
+	for(int i=0;i<this->gsize;i++){
 		/*assume dof is free, no constraints, no rigid body constraint: */
 		this->f_set[i]=true;
@@ -151,6 +147,4 @@
 void DofIndexing::Echo(void){
 
-	int i;
-
 	_printLine_("DofIndexing:");
 	_printLine_("   gsize: " << gsize);
@@ -168,5 +162,5 @@
 	_printLine_("   ssize: " << ssize);
 	_printLine_("   clone: " << clone);
-	
+
 	_printLine_("   set membership: f,s sets ");
 	for(i=0;i<gsize;i++){
@@ -208,3 +202,2 @@
 }		
 /*}}}*/
-
Index: issm/trunk/src/c/classes/DofIndexing.h
===================================================================
--- issm/trunk/src/c/classes/DofIndexing.h	(revision 13405)
+++ issm/trunk/src/c/classes/DofIndexing.h	(revision 13975)
@@ -9,28 +9,27 @@
 
 class DofIndexing{
-	
+
 	public:
 
 		/*sizes: */
-		int gsize; //number of dofs for a node
-		int fsize; //number of dofs solver for
-		int ssize; //number of constrained dofs
+		int gsize;   //number of dofs for a node
+		int fsize;   //number of dofs solver for
+		int ssize;   //number of constrained dofs
 
 		/*partitioning: */
-		int     clone;   //this node is replicated from another one 
+		bool clone;   //this node is replicated from another one
 
 		/*boundary conditions sets: */
-		bool*     f_set; //is dof on f-set (on which we solve)
-		bool*     s_set; //is dof on s-set (on which boundary conditions -dirichlet- are applied)
-		IssmDouble*   svalues; //list of constraint values. size g_size, for ease of use.
+		bool       *f_set;     //is dof on f-set (on which we solve)
+		bool       *s_set;     //is dof on s-set (on which boundary conditions -dirichlet- are applied)
+		IssmDouble *svalues;   //list of constraint values. size g_size, for ease of use.
 
 		/*types of dofs: */
-		int*     doftype; //approximation type of the dofs (used only for coupling), size g_size
-		
+		int        *doftype;   //approximation type of the dofs (used only for coupling), size g_size
+
 		/*list of degrees of freedom: */
-		int*     gdoflist; //dof list in g_set
-		int*     fdoflist; //dof list in f_set
-		int*     sdoflist; //dof list in s_set
-
+		int *gdoflist;   //dof list in g_set
+		int *fdoflist;   //dof list in f_set
+		int *sdoflist;   //dof list in s_set
 
 		/*DofIndexing constructors, destructors {{{*/
Index: issm/trunk/src/c/classes/FemModel.cpp
===================================================================
--- issm/trunk/src/c/classes/FemModel.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/FemModel.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: implementation of the FemModel object
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -13,4 +12,5 @@
 #include "../Container/Container.h"
 #include "../modules/ModelProcessorx/ModelProcessorx.h"
+#include "../solutions/solutions.h"
 #include "../io/io.h"
 #include "./classes.h"
@@ -20,70 +20,89 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION FemModel::constructor {{{*/
-FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, const int in_solution_type,const int* analyses,const int nummodels){
-
-	/*intermediary*/
-	int         i;
-	int         analysis_type;
-	FILE       *IOMODEL = NULL;
-	extern int  my_rank;
-
-	/*Open input file on cpu 0: */
-	if(my_rank==0) IOMODEL = pfopen(inputfilename ,"rb");
-
-	/*Initialize internal data: */
-	this->nummodels=nummodels;
-	this->solution_type=in_solution_type;
-	this->analysis_counter=nummodels-1; //point to last analysis_type carried out.
-	this->results=new Results(); //not initialized by CreateDataSets
+/*FUNCTION FemModel::FemModel(int argc,char** argv){{{*/
+FemModel::FemModel(int argc,char** argv,COMM incomm){
+
+	/*configuration: */
+	int* analyses=NULL;
+	int  numanalyses;
+	int  solution_type;
+	int  ierr;
+
+	/*File names*/
+	char *lockfilename   = NULL;
+	char *binfilename    = NULL;
+	char *outbinfilename = NULL;
+	char *petscfilename  = NULL;
+	char *rootpath       = NULL;
+
+	/*First things first, store the communicator, and set it as a global variable: */
+	this->comm=incomm;
+	this->SetStaticComm();
 	
-	/*Dynamically allocate whatever is a list of length nummodels: */
-	analysis_type_list=xNew<int>(nummodels);
-
-	/*Initialize: */
-	for(i=0;i<nummodels;i++)analysis_type_list[i]=analyses[i];
-
-	/*create datasets for all analyses*/
-	ModelProcessorx(&this->elements,&this->nodes,&this->vertices,&this->materials,&this->constraints,&this->loads,&this->parameters,IOMODEL,rootpath,this->solution_type,nummodels,analyses);
-
-	/*do the post-processing of the datasets to get an FemModel that can actually run analyses: */
-	for(i=0;i<nummodels;i++){
-
-		if(VerboseMProcessor()) _pprintLine_("   Processing finite element model of analysis " << EnumToStringx(analysis_type_list[i]) << ":");
-		analysis_type=analysis_type_list[i];
-		this->SetCurrentConfiguration(analysis_type);
-	
-		if(i==0){
-			if(VerboseMProcessor()) _pprintLine_("      creating vertex degrees of freedom");
-			VerticesDofx(vertices,parameters); //only call once, we only have one set of vertices
-		}
-
-		if(VerboseMProcessor()) _pprintLine_("      resolving node constraints");
-		SpcNodesx(nodes,constraints,parameters,analysis_type); 
-
-		if(VerboseMProcessor()) _pprintLine_("      creating nodal degrees of freedom");
-		NodesDofx(nodes,parameters,analysis_type);
-	
-		if(VerboseMProcessor()) _pprintLine_("      configuring element and loads");
-		ConfigureObjectsx(elements, loads, nodes, vertices, materials,parameters);
-	}
-	
-	/*Close input file descriptors: */
-	if(my_rank==0) pfclose(IOMODEL,inputfilename);
-
-	/*Add output file name to parameters: */
-	this->parameters->AddObject(new StringParam(OutputfilenameEnum,outputfilename));
-
-}
-
-/*}}}*/
-/*FUNCTION FemModel::destructor {{{*/
+	/*Now, initialize PETSC: */
+	#ifdef _HAVE_PETSC_
+	PETSC_COMM_WORLD=this->comm;
+	ierr=PetscInitialize(&argc,&argv,(char*)0,"");  if(ierr) _error_("Could not initialize Petsc");
+	#endif
+
+	/*Start profiler: */
+	this->profiler=new Profiler();
+	profiler->Tag(Start);
+
+	/*From command line arguments, retrieve different filenames needed to create the FemModel: */
+	ProcessArguments(&solution_type,&binfilename,&outbinfilename,&petscfilename,&lockfilename,&rootpath,argc,argv);
+
+	/*out of solution_type, figure out types of analyses needed in the femmodel: */
+	AnalysisConfiguration(&analyses,&numanalyses,solution_type);
+
+	/*Create femmodel from input files: */
+	profiler->Tag(StartInit);
+	this->InitFromFiles(rootpath,binfilename,outbinfilename,petscfilename,lockfilename,solution_type,analyses,numanalyses);
+	profiler->Tag(FinishInit);
+
+	/*Free resources */
+	xDelete<int>(analyses);
+	xDelete<char>(lockfilename);
+	xDelete<char>(binfilename);
+	xDelete<char>(outbinfilename);
+	xDelete<char>(petscfilename);
+	xDelete<char>(rootpath);
+
+}
+/*}}}*/
+/*FUNCTION FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){{{*/
+FemModel::FemModel(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){
+
+	/*Call InitFromFiles. This constructor is just a wrapper: */
+	this->InitFromFiles(rootpath, inputfilename, outputfilename, petscfilename, lockfilename, in_solution_type,analyses,nummodels);
+
+}
+/*}}}*/
+/*FUNCTION FemModel::~FemModel{{{*/
 FemModel::~FemModel(){
 
 	/*Intermediary*/
-	int i;
+	FILE *output_fid;
+	char *outbinfilename = NULL;
+	char *lockfilename   = NULL;
+	bool  waitonlock     = false;
+
+	/*Close output file: */
+	this->parameters->FindParam(&output_fid,OutputFilePointerEnum); 
+	this->parameters->FindParam(&outbinfilename,OutputFileNameEnum); 
+	pfclose(output_fid,outbinfilename);
+
+	/*Write lock file if requested: */
+	this->parameters->FindParam(&waitonlock,SettingsWaitonlockEnum);
+	this->parameters->FindParam(&lockfilename,LockFileNameEnum);
+	if (waitonlock>0){
+		_pprintLine_("write lock file:");
+		WriteLockFile(lockfilename);
+	}
 
 	/*Delete all the datasets: */
 	xDelete<int>(analysis_type_list);
+	xDelete<char>(outbinfilename);
+	xDelete<char>(lockfilename);
 	delete elements;
 	delete nodes;
@@ -95,4 +114,26 @@
 	delete results;
 
+	/*Before we delete the profiler, report statistics for this run: */
+	profiler->Tag(Finish);  //final tagging
+	_pprintLine_("");
+	_pprintLine_("   "<<setw(40)<<left<<"FemModel initialization elapsed time:"<<profiler->DeltaTime(StartInit,FinishInit));
+	_pprintLine_("   "<<setw(40)<<left<<"Core solution elapsed time:"<<profiler->DeltaTime(StartCore,FinishCore));
+	_pprintLine_("");
+	_pprintLine_("   Total elapsed time:"
+			<<profiler->DeltaTimeModHour(Start,Finish)<<" hrs "
+			<<profiler->DeltaTimeModMin(Start,Finish)<<" min "
+			<<profiler->DeltaTimeModSec(Start,Finish)<<" sec"
+			);
+	_pprintLine_("");
+
+	/*Now delete: */
+	delete profiler;
+	
+	/*Finalize PETSC for this model: */
+	#ifdef _HAVE_PETSC_
+	_pprintLine_("closing Petsc");
+	PetscFinalize(); 
+	#endif
+
 }
 /*}}}*/
@@ -111,6 +152,94 @@
 }
 /*}}}*/
-
-/*Numerics: */
+/*FUNCTION FemModel::InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){{{*/
+void FemModel::InitFromFiles(char* rootpath, char* inputfilename, char* outputfilename, char* petscfilename, char* lockfilename, const int in_solution_type,const int* analyses,const int nummodels){
+
+	/*intermediary*/
+	int         i;
+	int         analysis_type;
+	FILE       *IOMODEL = NULL;
+	FILE       *petscoptionsfid = NULL;
+	FILE       *output_fid = NULL;
+	int         my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	/*Open input file on cpu 0: */
+	if(my_rank==0) IOMODEL = pfopen(inputfilename ,"rb");
+
+	/*Initialize internal data: */
+	this->nummodels        = nummodels;
+	this->solution_type    = in_solution_type;
+	this->analysis_counter = nummodels-1;   //point to last analysis_type carried out.
+	this->results          = new Results(); //not initialized by CreateDataSets
+
+	/*Dynamically allocate whatever is a list of length nummodels: */
+	analysis_type_list=xNew<int>(nummodels);
+
+	/*Initialize: */
+	for(i=0;i<nummodels;i++)analysis_type_list[i]=analyses[i];
+
+	/*create datasets for all analyses*/
+	ModelProcessorx(&this->elements,&this->nodes,&this->vertices,&this->materials,&this->constraints,&this->loads,&this->parameters,IOMODEL,rootpath,this->solution_type,nummodels,analyses);
+
+	/*do the post-processing of the datasets to get an FemModel that can actually run analyses: */
+	for(i=0;i<nummodels;i++){
+
+		if(VerboseMProcessor()) _pprintLine_("   Processing finite element model of analysis " << EnumToStringx(analysis_type_list[i]) << ":");
+		analysis_type=analysis_type_list[i];
+		this->SetCurrentConfiguration(analysis_type);
+
+		if(i==0){
+			if(VerboseMProcessor()) _pprintLine_("      creating vertex degrees of freedom");
+			VerticesDofx(vertices,parameters); //only call once, we only have one set of vertices
+		}
+
+		if(VerboseMProcessor()) _pprintLine_("      resolving node constraints");
+		SpcNodesx(nodes,constraints,parameters,analysis_type); 
+
+		if(VerboseMProcessor()) _pprintLine_("      creating nodal degrees of freedom");
+		NodesDofx(nodes,parameters,analysis_type);
+
+		if(VerboseMProcessor()) _pprintLine_("      configuring element and loads");
+		ConfigureObjectsx(elements, loads, nodes, vertices, materials,parameters);
+	}
+
+	/*Close input file descriptors: */
+	if(my_rank==0) pfclose(IOMODEL,inputfilename);
+
+	/*Open output file once for all and add output file name and file descriptor to parameters*/
+	output_fid=pfopen(outputfilename,"wb");
+	this->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
+	this->parameters->SetParam(output_fid,OutputFilePointerEnum);
+
+	/*Save lock file name for later: */
+	this->parameters->AddObject(new StringParam(LockFileNameEnum,lockfilename));
+
+	/*Now, deal with petsc options, which need to be put into the parameters dataset: */
+	petscoptionsfid=pfopen(petscfilename,"r");
+	ParsePetscOptionsx(this->parameters,petscoptionsfid);
+	pfclose(petscoptionsfid,petscfilename);
+}
+/*}}}*/
+/*FUNCTION FemModel::OutputResults {{{*/
+void FemModel::OutputResults(void){
+
+	_pprintLine_("write results to disk:");
+
+	/*Just call the OutputResultsx module: */
+	OutputResultsx(this->elements, this->nodes, this->vertices, this->loads, this->materials, this->parameters,this->results);
+
+}
+/*}}}*/
+/*FUNCTION FemModel::SetStaticComm {{{*/
+void FemModel::SetStaticComm(void){
+
+	/*This routine sets the global communicator variable hidden inside the IssmComm 
+	 *class: */
+	IssmComm::SetComm(this->comm);
+
+}
+/*}}}*/
 /*FUNCTION FemModel::SetCurrentConfiguration(int configuration_type,int analysis_type){{{*/
 void FemModel::SetCurrentConfiguration(int configuration_type,int analysis_type){
